<template>
  <section>
    <div class="flex">
      <div class="max-w-xs">
        <label for="wallet" class="block text-sm font-medium text-gray-700"
        >Тикер</label
        >
        <div class="mt-1 relative rounded-md shadow-md">
          <input
              v-model="cryptName"
              @keydown.enter="addTicker"
              type="text"
              name="wallet"
              id="wallet"
              class="block w-full pr-10 border-gray-300 text-gray-900 focus:outline-none focus:ring-gray-500 focus:border-gray-500 sm:text-sm rounded-md"
              placeholder="DOGE as example"
          />
        </div>

        <search-suggestions
            :search-value="cryptName"
            v-on:suggestion="handleSuggestionsUpdate($event)"
            v-on:suggestion-selected="handleSuggestionSelection($event)"
        />

        <div v-if="!isValidTicker" class="text-sm text-red-600">This ticker already added</div>
      </div>
    </div>
    <button-default
        @click="addTicker"
    >
      <svg
          class="-ml-0.5 mr-2 h-6 w-6"
          xmlns="http://www.w3.org/2000/svg"
          width="30"
          height="30"
          viewBox="0 0 24 24"
          fill="#ffffff"
      >
        <path
            d="M13 7h-2v4H7v2h4v4h2v-4h4v-2h-4V7zm-1-5C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 18c-4.41 0-8-3.59-8-8s3.59-8 8-8 8 3.59 8 8-3.59 8-8 8z"
        ></path>
      </svg>
      Add ticker
    </button-default>
  </section>
</template>

<script>
import DefaultButton from "@/components/stock/DefaultButton";
import SearchSuggestions from "@/components/SearchSuggestions";

export default {
  name: "TickerInput",
  props: {
    existingTickers: {
      type: Array,
      required: true
    }
  },

  components: {
    "button-default" : DefaultButton,
    "search-suggestions": SearchSuggestions
  },

  emits:["addTicker"],

  data() {
    return {
      cryptName: "",
      searchSuggestions: []
    }
  },

  methods: {
    addTicker() {
      if (this.cryptName && this.isValidTicker) {
        const newTickerObject = {
          id: new Date().getMilliseconds(),
          name: this.cryptName.toUpperCase(),
          price: "-",
          errorMsg: null
        }
        this.$emit("addTicker", newTickerObject)
        this.cryptName = "";
      }
    },

    handleSuggestionsUpdate(suggestions) {
      this.searchSuggestions = suggestions
    },

    handleSuggestionSelection(tickerSymbol) {
      if (tickerSymbol) {
        this.cryptName = tickerSymbol;
        this.addTicker();
      }
    }
  },

  computed: {
    isValidTicker() {
      let isTickerExist = false;
      this.existingTickers.forEach((element) => {
        if (element.name.toLowerCase() === this.cryptName.toLowerCase()) {
          isTickerExist = true;
        }
      })
      return !isTickerExist;
    }
  },
}
</script>